import {Component, EventEmitter, Input, Output} from '@angular/core';
import {FormControl, Validators} from "@angular/forms";
import {BasicScheduleEntityInfo, ScheduleService, TaskEntityInfo} from "../../../api";
import {MatSnackBar} from "@angular/material/snack-bar";

@Component({
  selector: 'app-basic-scheduler',
  templateUrl: './basic-scheduler.component.html',
  styleUrls: ['./basic-scheduler.component.css']
})
export class BasicSchedulerComponent {

  dateCtrl: FormControl = new FormControl('', [Validators.required])
  @Input('task') task: TaskEntityInfo | undefined
  @Output('onSchedule') scheduleEmitter: EventEmitter<BasicScheduleEntityInfo> = new EventEmitter<BasicScheduleEntityInfo>();

  constructor(private scheduleService: ScheduleService,
              private snackbar: MatSnackBar) {
  }

  setDate(date: Date) {
    this.dateCtrl.setValue(date);
  }

  schedule() {
    if(this.task != undefined) {
      this.scheduleService.schedulesTaskIDBasicPut(this.task.taskID, {
        scheduleDate: this.dateCtrl.value
      }).subscribe({
        next: resp => {
          this.scheduleEmitter.emit(resp);
        }
      })
    }

  }
}
